﻿#include <iostream>
#include "BST.h"
using namespace std;

BST::BST():root(NULL) {}

BST::BST(int tab[], int size) {
	for (int i = 0; i < size; i++)
		insert(root, tab[i]);
}

bool BST::insert(BSTNode*& node, int wartosc) {
	if (node == NULL) { // tworzymy i dołączamy węzeł          
		node = new BSTNode;
		node->data = wartosc;
		node->left = NULL;
		node->right = NULL;
		return true;
	}
	else
		if (wartosc < node->data) return insert(node->left, wartosc);    // rekurencyjne wywolanie              
		else
			if (wartosc > node->data) return insert(node->right, wartosc); // rekurencyjne wywolanie            
		  // uwaga: liczby powtarzające się nie są dodawane do drzewa 
	
	return false;
}

//BSTNode* BST::search(int key) {}

//BSTNode* BST::search(BSTNode* node, int key) {}

//int BST::minKey() {}

//int BST::minKey(BSTNode* node) {}

//int BST::maxKey() {}

//void BST::inorder(BSTNode* x) {}

//void BST::preorder(BSTNode* x) {}

//void BST::postorder(BSTNode* x) {}

void BST::print(BSTNode* x){
	if (!x->left && !x->right) return;

	cout << x->data << " : lewy-> ";
	if (x->left) cout << x->left->data;
	else        cout << "NULL";
	
	cout << ", prawy-> ";
	if (x->right) cout << x->right->data;
	else         cout << "NULL";
	cout << endl;
	
	if (x->left)  print(x->left);
	if (x->right) print(x->right);
}

void BST::remove(BSTNode* x) {
	if (!x) return;
	remove(x->left);
	remove(x->right);
	cout << "usuwam " << x->data << endl;
	delete x;
}